;SETSCRN.COM  Copyright 1984  Kenneth A. Lively   Version 1.6
;
;Program to modify the screen dump boundaries used by the
;graphics screen dump program SCREEN.COM.
;version 1.5 added feature to view current boundary settings
;version 1.6 includes the Okidata 82/92 version of SCREEN.ASM
;
esc     equ     1bh
cr      equ     13
lf      equ     10
bell    equ     7
tab	equ	9
int_5   equ     0016H
code    segment
        assume  cs:code,ds:code,ss:code,es:code
        org     100h
begin:  jmp     start           ;jump past data area
f_row   db      ?               ;first row
l_row   db      ?               ;last row
f_col   db      ?               ;first column
l_col   db      ?               ;last column
color   db      ?               ;color setting
        db      7               ;this needed for the chk_rng routine
v_flg	db	0		;this flag used for displaying current settings
chg_flg db	0		;this flag set if any changes are made
int5_seg  dw    ?               ;segment of the screen dump program
version db	17		;version number of the screen dump program
ver_offset  dw	?		;address of table in screen dump routine
mode    db      ?
err_msg1  db    bell,cr,lf,lf,'Install screen dump service routine by executing'
          db    cr,lf,'SCREEN.COM before attempting to set parameters.'
          db    cr,lf,'$'
err_msg2  db    bell,cr,lf,lf,'Invalid option specified',cr,lf,'$'
err_msg3  db    bell,cr,lf,lf,'Invalid numeric parameter',cr,lf,'$'
err_msg4  db    bell,cr,lf,lf,'Unexpected end of command tail',cr,lf,'$'
err_msg5  db    bell,cr,lf,lf,'Invalid color option - color memory not present'
          db    cr,lf,'$'
done_msg  db	cr,lf,'Changes complete',cr,lf,'$'
useage	  db	esc,'E','SETSCRN.COM  version 1.7   Copyright 1983 Kenneth A. '
          db    'Lively',cr,lf,lf
          db    'Program to modify the default screen dump boundaries for '
          db    'SCREEN.COM',cr,lf
          db    'Invoke by typing SETSCRN[options] where the options are:',cr,lf
	  db	'/FRn to specify the First Row in the dump',cr,lf
	  db	'/LRn to specify the Last Row in the dump',cr,lf
	  db	'/FCn to specify the First Column in the dump',cr,lf
	  db	'/LCn to specify the Last Column in the dump',cr,lf
	  db	'/SCn to specify the colors present in the dump',cr,lf
	  db	'/? to view current screen dump boundaries',cr,lf,lf
          db    'The options may be specified in any order and in upper',cr,lf
	  db	'or lower case.  Embedded spaces are NOT allowed and the',cr,lf
	  db	'numeric parameter n must be between 0 and 79 for column,',cr,lf
	  db	'between 0 and 24 for row, and between 0 and 7 for color.',cr,lf
          db    'Also, first <= last for row and column.',cr,lf,lf
          db    'An example:  SETSCRN/FR0/LR24/FC0/LC79/SC4',cr,lf,lf,'$'
view_msg  db	cr,lf,'Current Screen Dump Boundaries are:',cr,lf,lf,tab,'Rows '
view_1	  db	'nn through '
view_2	  db	'nn',cr,lf,tab,'Cols '
view_3	  db	'nn through '
view_4	  db	'nn',cr,lf,tab,'Color '
view_5	  db	'n',cr,lf,'$'
;
start:  in      al,0d8h                 ;first, make sure that we
        mov     mode,al                 ;  have access to video ram
        and     al,7fh                  ;save it though, so we can put
        out     0d8h,al                 ;  it back the way it was
        xor     ax,ax                   ;clear ax and
        mov     es,ax                   ;  point to the interrupt page
        mov     di,offset int5_seg
        mov     si,int_5
        mov     ax,es:[si]              ;get the segment for the screen prog.
        mov     [di],ax                 ;  and store it
        mov     es,ax                   ;now go to the screen prog and
	mov	si,103H 		;  move past JMP to START
	mov	ax,es:[si]
	mov	ver_offset,ax		; save address of VERSION from driver
	mov	si,ver_offset		;  check the version number
        mov     al,es:[si]
        cmp     al,version
        jz      get_old                 ;if ok, get the old values
        mov     dx,offset err_msg1      ;else exit with an error
	jmp	exit
get_old:
        inc     si                      ;set up to read the current boundaries
        mov     di,offset f_row         ; into local storage
        mov     cx,5
get_1:  mov     al,es:[si]
        mov     [di],al
        inc     di
        inc     si
        loop    get_1
        mov     si,80h                  ;now lets look at the cmd line tail
        mov     cl,[si]                 ;get the count into cx
        xor     ch,ch
        inc     si                      ;point to the first char
        cmp     byte ptr [si],'/'       ;if anything but a '/', print the
        jz      tail_ok                 ;  useage msg and exit
        mov     dx,offset useage
	jmp	exit
tail_ok:                                ;must have been ok
        inc     si                      ;fix pointer and count
        dec     cx
loop:   mov     ax,[si]                 ;arrive here pointing at the first char
                                        ;  past a '/' (always)
        add     si,2                    ;fix up ptr and count as we are taking
        sub     cl,2                    ;  the next two chars at once
        call    decode                  ;look for fc,lc,fr,lr or sc, and get the
                                        ;  ptr to the data area into di
        jnc     loop1                   ;carry set for errors (always fatal)
        mov     dx,offset err_msg2
	jmp	exit
loop1:	cmp	v_flg,1 		;did we just set the view flag?
	jnz	loop2			;no, continue
	mov	v_flg,2 		;yes, set it to two, and fix up
	dec	si			;  si and cl for next parameter
	inc	cl
	jmp	loop4
loop2:	mov	chg_flg,1		;indicate a boundary change took place
	mov	ah,30h			;this covers case of a single digit
        mov     al,[si]                 ;get the ascii number
        inc     si                      ;fix ptr and count
        dec     cl
        call    chkdig                  ;check the digit for being 30h to 39h
	jc	err_exit3		;no, then exit with msg
	cmp	byte ptr [si],'/'	;if the next char is a '/' or if cl=0,
        jz      loop3                   ;  then this option done
        cmp     cl,0
        jz      loop3
        mov     ah,al                   ;else move first digit over and get
        mov     al,[si]                 ;  the other one
        inc     si                      ;fix em up again
        dec     cl
        call    chkdig                  ;check over this one too
	jc	err_exit3		;if ok, continue
loop3:  call    asc2hx                  ;convert to hex and ret the value in al
        mov     [di],al                 ;  and store it
loop4:	cmp	byte ptr [si],'/'	;if next char not a '/', then we are
        jnz     done                    ;  done or somebody goofed
        inc     si                      ;have a '/', so fix ptr and count and
        dec     cl                      ;  get the next option
        jmp     loop
done:   cmp     cl,0                    ;if cl not zero, have a bad cmd line
        jz      mk_chgs
        mov     dx,offset err_msg4
exit:	call	prn_msg
exit_1: mov	al,mode 		;restore the mode at the video port
	out	0d8h,al
	int	20h
err_exit3:				;common exit for bad numeric parameter
	mov	dx,offset err_msg3
	jmp	exit
;subroutines follow
mk_chgs:                                ;now for some checking of the values
        mov     si,offset f_row
	mov	al,[si]
	cmp	al,[si+1]
	jg	err_exit3
        mov     ah,24                   ;first the row range (0-24)
        call    chk_rng
	jc	err_exit3
	mov	si,offset f_col 	;and then the column range
	mov	al,[si]
	cmp	al,[si+1]
	jg	err_exit3
        mov     ah,79
        call    chk_rng
	jc	err_exit3
	mov	si,offset color 	;now check the color byte
	mov	ah,7			;first make sure its between 0 and 7
	call	chk_rng
	jc	err_exit3
	cmp	color,4 		;next check that we have color memory
	jz	mk_4			;  if anything but green is specified
	mov	bx,0			;we'll look at the first byte in red
	mov	dx,0d000h		;  memory
	mov	es,dx			;assumption: if red present than so is
					;  blue (???)
	mov	al,es:[bx]		;get a copy of the byte
	inc	byte ptr es:[bx]	;try to increment it
	cmp	al,es:[bx]		;did we change it?
	jnz	mk_31			;yes, continue
	mov	dx,offset err_msg5	;else fatal error
	jmp	exit
mk_31:	dec	byte ptr es:[bx]	;change it back
mk_4:	cmp	v_flg,2 		;do we need to print out current values?
	jnz	mk_41			;no, skip
	mov	al,f_row		;else convert to ascii and poke into
	call	hx2asc			;  the view_msg string
	mov	word ptr view_1,ax
	mov	al,l_row
	call	hx2asc
	mov	word ptr view_2,ax
	mov	al,f_col
	call	hx2asc
	mov	word ptr view_3,ax
	mov	al,l_col
	call	hx2asc
	mov	word ptr view_4,ax
	mov	al,color
	add	al,30h
	mov	view_5,al
	mov	dx,offset view_msg
	call	prn_msg
	cmp	chg_flg,1		;were any changes made?
	jz	mk_41			;yes, go make them
	jmp	exit_1			;no, can exit now
mk_41:	mov	ax,int5_seg		;no errors, so make the changes
        mov     es,ax
	mov	di,ver_offset
	inc	di
;	mov	di,ver_offset+1
        mov     si,offset f_row
	mov	cx,5
mk_5:	mov	al,[si]
        mov     es:[di],al
        inc     si
        inc     di
	loop	mk_5
        mov     dx,offset done_msg      ;let user know that all went smooth
	jmp	exit
;
;subroutines follow
;
prn_msg  proc   near                    ;use print string fct to output a msg
        mov     ah,9
        int     21h
	ret				;exits to dos in case of an error
prn_msg endp
asc2hx  proc    near                    ;convert ascii digits in ah,al to a
        push    cx                      ;  hex value in al
        sub     ah,30h                  ;make it a 'real' number
        sal     ah,1                    ;mult by 2
        mov     ch,ah                   ;get a copy
        sal     ah,1                    ;mult by 4
        sal     ah,1
        add     ah,ch                   ;add the copy and have mult by 10
        sub     al,30h                  ;take care of the one's digit
        add     al,ah                   ;  and add it in
        pop     cx
        ret
asc2hx  endp
chkdig  proc    near                    ;check for a valid ascii digit in al
        cmp     al,30h                  ;set the carry flag if not valid
        jl      chk1
        cmp     al,39h
        jg      chk1
        clc
        ret
chk1:   stc
        ret
chkdig  endp
chk_rng proc    near                    ;check the range of two numbers where
                                        ;  si points to the first and si+1
                                        ;  points to the second
                                        ;low limit is zero and high limit is
                                        ;  in ah.  Carry set on error
        mov     cx,2
rng1:   cmp     byte ptr [si],0
	jl	rng2
        cmp     [si],ah
        jg      rng2
        inc     si
        loop    rng1
        clc
        ret
rng2:   stc
        ret
chk_rng endp
decode  proc    near                    ;convert letters to upper case if req'd
                                        ;  and get pointer to the option's data
                                        ;  area into di.  Carry set on no find
                                        ;ah,al have chars in reverse order
        xchg    ah,al                   ;put chars in right order so code makes
                                        ;  more sense
        cmp     ah,'Z'                  ;is the char upper case?
        jle     d1                      ;assume so if less than Z
        and     ah,5fh                  ;else convert it
d1:     cmp     al,'Z'                  ;also check the other one
        jle     d2
        and     al,5fh
d2:     cmp     ax,'FR'                 ;now look for the valid options and get
        jnz     d3                      ;  a pointer to the data area into di
        mov     di,offset f_row
	jmp	d9
d3:     cmp     ax,'FC'
        jnz     d4
        mov     di,offset f_col
	jmp	d9
d4:     cmp     ax,'LR'
        jnz     d5
        mov     di,offset l_row
	jmp	d9
d5:     cmp     ax,'LC'
        jnz     d6
        mov     di,offset l_col
	jmp	d9
d6:	cmp	ax,'SC'
	jnz	d7
	mov	di,offset color
	jmp	d9
d7:	cmp	ah,'?'
	jnz	d8
	mov	v_flg,1
	jmp	d9
d8:	stc				;error exit if no matches
        ret
d9:	clc				;normal exit
        ret
decode  endp
hx2asc  proc	near			;convert hex number in al to ascii
	xor	ah,ah			;  in ah,al (valid for al = 00 to 99)
	aam
	add	ax,3030h
	xchg	ah,al			;reverse order for word oriented
	ret				;  storage
hx2asc	endp
code	ends		 
        end     begin
