	PAGE	,132
; TP - PROGRAM TO ECHO BACK TO SCREEN AND PRINT LINE WHEN
; A CARRIAGE  RETURN IS FOUND.
;
;     (C)1983 LINDLEY SYSTEMS
;     Robert A. Lindley
;     V 1.0  15 Sep 1983  20:00
;     V 1.1   2 Oct 1983  10:00
;	     LF key now causes LF CR on screen, no print
;     V 1.2   6 Dec 1983  22:00
;	     Skips spaces at end of line
;     V 1.3  Set keyboard off during printing	2/23/86
;	       
;
PGMSEG	SEGMENT
	ASSUME	CS:PGMSEG,SS:PGMSEG,DS:PGMSEG,ES:NOTHING
	ORG	100H
CON_IN		EQU	1
CON_OUT 	EQU	2
PRINT_OUT	EQU	5
CON_DIRECT_IN	EQU	8
CON_STRING	EQU	9
CON_BUF_IN	EQU	10
BS	EQU	8
HT	EQU	9
LF	EQU	10
CR	EQU	13
ESC	EQU	27
SPACE	EQU	32
DELETE	EQU	127
;
BEGIN:	PUSH	CS
	POP	DS			;fix up data seg register
	MOV	AL,0
	CMP	AL,DS:80H
	JNZ	ECHO_KEY
	MOV	DX, OFFSET HELLO	;get sign-on message
	MOV	AH,CON_STRING
	INT	21H			;print sign-on
	MOV	AH,CON_DIRECT_IN
	INT	21H
	MOV	AH,CON_STRING
	MOV	DX,OFFSET CLS
	INT	21H
; ECHO INPUT UNTIL CR IS FOUND
ECHO_KEY:
	MOV	AH,CON_DIRECT_IN
	INT	21H
	CMP	AL,3	; CONTROL C
	JZ	GO_ZDOS
	CMP	AL,DELETE
	JZ	DO_DELETE
	CMP	AL,HT
	JZ	DO_TAB
	CMP	AL,LF
	JZ	DO_LF
	MOV	DL,AL
	MOV	AH,6
	PUSH	AX
	INT	21H
	POP	AX
	CMP	AL,CR
	JZ	FETCH_LINE
	JMP	ECHO_KEY
GO_ZDOS:
	MOV	AH,0
	INT	21H
DO_DELETE:
	MOV	AH,CON_STRING
	MOV	DX,OFFSET DELETE_CHAR
	INT	21H
	JMP	ECHO_KEY
DO_LF:	MOV	AH,CON_STRING
	MOV	DX,OFFSET CRLF
	INT	21H
	JMP	ECHO_KEY
DO_TAB: MOV	AH,CON_STRING
	MOV	DX,OFFSET GET_CUR_LOCATION
	INT	21H
	MOV	BX,OFFSET BUFFER
	MOV	CX,4
CUR_LOOP:
	MOV	AH,CON_DIRECT_IN
	INT	21H
	MOV	[BX],AL
	INC	BX
	LOOP	CUR_LOOP
	DEC	BX
	ADD	AL,8
	AND	AL,0F8H
	CMP	AL,111
  	JC	NOSUB
	SUB	AL,80
NOSUB:	MOV	[BX],AL
	INC	BX
	MOV	BYTE PTR [BX],'$'
	MOV	AH, CON_STRING
	MOV	DX, OFFSET BUFFER
	INT	21H
	JMP	ECHO_KEY
FETCH_LINE:
	MOV	AH,CON_STRING
	MOV	DX,OFFSET KB_OFF
	INT	21H
	MOV	DX, OFFSET GET_CON_LINE
	MOV	AH,CON_STRING
	INT	21H
	MOV	BX, OFFSET BUFFER
	MOV	CX, 1
GET_NEXT_CHARACTER:
	MOV	AH,CON_DIRECT_IN
	INT	21H
	MOV	[BX],AL
	CMP	AL,CR
	JZ	GOT_ALL
	INC	BX
	INC	CX
	JMP	SHORT GET_NEXT_CHARACTER
GOT_ALL:
	MOV	AL,SPACE
DROP_SPACES:
	DEC	BX
	DEC	CX
	JZ	LINEND
	CMP	AL,[BX]
	JZ	DROP_SPACES
LINEND:
	INC	CX
	INC	BX
	MOV	BYTE PTR [BX],CR
	INC	CX
	INC	BX
	MOV	BYTE PTR [BX],LF
	MOV	AH,CON_OUT	; LF TO SCREEN
	MOV	DL,LF
	INT	21H
;
; SEND CHARACTERS TO PRINTER
	MOV	BX,OFFSET BUFFER
	MOV	BYTE PTR CCC_SW,0
; CX  HAS CHARACTER COUNT
PRINT_LOOP:			; PRINT CONTENTS OF BUFFER
	MOV	DL,[BX]
	INC	BX
	MOV	AH,BYTE PTR CCC_SW ; TEST FOR CONVERSION IN PROGRESS
	MOV	BYTE PTR CCC_SW, 0
	OR	AH,AH
	JZ	PL_1
	CMP	DL,BYTE PTR CCC ; 2ND TILDE?
	JZ	PL_2		; PRINT ONE TILDE
	CMP	DL,'&'
	JNZ	PL_A
	DEC	CX
	DEC	CX
	JMP	PL_3
PL_A:	AND	DL,01FH 	; CONVERT TO CONTROL RANGE
	JMP	PL_2
PL_1:	CMP	DL,BYTE PTR CCC ; LOOK FOR CONVERSION START
	JNZ	PL_2
	MOV	BYTE PTR CCC_SW, 0FFH
	JMP	PL_3
PL_2:	MOV	AH,PRINT_OUT
	INT	21H
PL_3:	LOOP	PRINT_LOOP
	MOV	AH,CON_STRING
	MOV	DX,OFFSET KB_ON
	INT	21H
	JMP	ECHO_KEY
;
; SIGN ON MESSAGE
HELLO:	DB	ESC,'E'
	DB	'TP Ver. 1.3 (C)1986 Lindley Systems',CR,LF,LF
	DB	'Use TP/X to omit this message.',CR,LF,LF
	DB	'What you type here will be printed '
	DB	'line by line on device LST.',CR,LF,LF
	DB	'RETURN prints entire line that contains '
	DB	'the cursor.',CR,LF,LF
	DB	'LINE FEED goes to next line without printing.'
	DB	CR,LF,LF
	DB	'~~ prints one ~     ~[ is printer escape    ',CR,LF
	DB	'~& sends line to printer without CR or LF',CR,LF
	DB	'~  next character is a printer control character.'
	DB	CR,LF,LF
	DB	'Type CTRL-C to exit program.',CR,LF,LF
	DB	'Type a space to begin session.'
CRLF	DB	CR,LF,'$'
CLS	DB	27,'E$'
KB_OFF	DB	27,'}$'
KB_ON   DB      27,'{$'
GET_CUR_LOCATION  DB	ESC,'n$'
DELETE_CHAR	DB	BS,ESC,'N$'
GET_CON_LINE	DB	ESC,'O',ESC,'^$'
CCC	DB	126	;TILDE CHARACTER
CCC_SW	DB	0
COUNT	DW	0
BUFFER	DB	256 DUP(?)
;
PGMSEG	ENDS
	END	BEGIN
